let Genode = env:DHALL_GENODE

let Init = Genode.Init

let Child = Init.Child

let init =
      Init::{
      , children = toMap
          { solo5 =
              Child.flat
                Child.Attributes::{
                , binary = "solo5-test_blk"
                , exitPropagate = True
                , resources = Init.Resources::{
                  , caps = 256
                  , ram = Genode.units.MiB 3
                  }
                , routes =
                  [ Init.ServiceRoute.parent "Timer"
                  , Init.ServiceRoute.child "Block" "block"
                  ]
                }
          , block =
              Child.flat
                Child.Attributes::{
                , binary = "vfs_block"
                , provides = [ "Block" ]
                , resources = Init.Resources::{ ram = Genode.units.MiB 12 }
                , config = Init.Config::{
                  , content =
                    [ Genode.Prelude.XML.text
                        ''
                        <vfs>
                          <ram/>
                          <import>
                            <zero name="block.raw" size="8M"/>
                          </import>
                        </vfs>
                        ''
                    ]
                  , defaultPolicy = Some Init.Config.DefaultPolicy::{
                    , attributes = toMap
                        { file = "block.raw", writeable = "yes" }
                    }
                  }
                }
          }
      }

in  Init.toChild init Init.Attributes.default
